local colour = {"Hearts", "Spades", "Clubs", "Diamonds"}
local cards = {"Ace", "Two", "Three", "Four", "Five", "Six", "Seven", "Eight", "Nine", "Ten", "Jack", "Queen", "King"}
local numbers = {"one ", "two ", "three ", "four ", "five ", "six ", "seven ", "eight ", "nine ", "ten ", "eleven ", "twelve ", "thirteen "}
local deck = {}
local tarot = {"The Fool", "The Magician", "The High Priestess", "The Empress", "The Emperor", "The Hierophant", "The Lovers", "The Chariot", "Strength", "The Hermit", "Wheel of Fortune", "Justice", "The Hanged Man", "Death", "Temperance", "The Devil", "The Tower", "The Star", "The Moon", "The Sun", "Judgement", "The World"}
local eightballtable = {"It is certain","It is decidedly so","Without a doubt","Yes definitely","You may rely on it","As I see it, yes","Most likely","Outlook good","Signs point to yes","Reply hazy try again","Ask again later","Better not tell you now","Cannot predict now","Concentrate and ask again","Don't count on it","My reply is no","My sources say no","Outlook not so good","Very doubtful"}
local CurrentCard = 0
local CurrentTarot = 0
local drawncards = ""
local drawn = {}
local plu = ""
local user = UnitName("player")
local target = nil
local gender = UnitSex("player")
local spinList = {}
local pronouns = {{},
	{"His","his","He","he","Man","man"},
	{"Her","her","She","she","Woman","woman"}
}

local sipEmotes = {
	"takes a sip of %s %s.",
	"sips %s %s.",
	"takes a slow sip of %s %s.",
	"raises her glass to sip some of %s %s.",
	"sips a little of %s %s, savouring the taste before swallowing.",
	"raises %s %s to %s lips, inhaling deeply before deciding to take a sip."
}

local helpTable = {
	"/8ball [Question] - This asks the magic 8ball, shakes it and then gives you a randomly selected response.",
	"/draw [Number] - Draws a number of cards specified from a 52 Deck of Cards. If the will automatically shuffle the deck if needed.",
	"/shuffle - Shuffles the Deck of Cards, use if you want to reset the deck before it's empty.",
	"/check - Checks how many cards remain in the current deck without drawing any.",
	"/tdraw [Number] - Draws a number of cards specified from the Tarot Deck. If the will automatically shuffle the deck if needed.",
	"/tshuffle - Shuffles the Tarot Deck, use if you want to reset the deck before it's empty.",
	"/tcheck - Checks how many cards remain in the tarot deck without drawing any.",
	"/flip - Flips a coin in the air and displays the result.",
	"/spin [option] - Spins a bottle for the players listed. If no list exists then one is generated from your present group/raid (excluding offline players). If S is supplied player will be ouput to the user only.",
	"/spinlist [List] - Used to populate a list for the Spin the Bottle command. If nothing is provided will list the current one instead.",
	"Blackjack - Use /deal and /hit to deal out cards to the targetted player. Deal provides two cards, Hit provides one. Use /shuffle to re-shuffle your deck.",
	"Custom Emotes - /snod, /smilenod, /wag, /smug, /smuggrin, /squint, /sip [Drink], /shakehead, /shakeh"
}

local function getGroup(members)
	--local SubGroups = math.ceil(members/5)
	local GroupSize = GetNumGroupMembers()
	local Group = {}
	local CurrMember = 0
	local VMem = 0
	for i = 1,GroupSize do
		local name, rank, subgroup, level, class, fileName, zone, online = GetRaidRosterInfo(i)
		if online then
			VMem = VMem + 1
			Group[VMem] = name
		end
	end
	return Group	
end

local function emoteFormat(emote,...)
	local str = ""
	local f,s,t,fo,fi,si,se = ...
	str = string.format(emote,f,s,t,fo,fi,si,se)
	return str
end

local function getRandomPlayer(i, Party)
	local Player = ""
	if #Party <= 1 then 
		return nil
	end
	if i == 1 then
		while true do
			Player = Party[math.random(#Party)]
			if Player ~= user then
				return Player
			end
		end
	elseif i == 2 then
		Player = Party[math.random(#Party)]
		return Player
	end
end

local function eightball(question)
	local fortune = math.random(#eightballtable)
	local output = ""
	if question ~= "" then
		output = string.format("reaches into %s pocket and lifts out a magic 8-Ball. %s quietly asks %q and then shakes it. The 8-Ball answers %q.",pronouns[gender][2],pronouns[gender][3],question,eightballtable[fortune])
	else
		output = string.format("shakes %s magic 8-Ball and looks at the response. It reads %q.",pronouns[gender][2],eightballtable[fortune])
	end
	SendChatMessage(output,"EMOTE")
end

local function shuffle(tbl)
  size = #tbl
  for i = size, 1, -1 do
    local rand = math.random(size)
    tbl[i], tbl[rand] = tbl[rand], tbl[i]
  end
  return tbl
end

local function shuffledeck()
	for i=1,52 do
		local mod = (i % 4) + 1
		local num = math.ceil(i/4)
		local string = cards[num].. " of "..colour[mod]
		deck[i] = string
	end
	shuffle(deck)
	CurrentCard = #deck
	PlaySound(53186)
	SendChatMessage("picks up "..pronouns[gender][2].." deck of cards and shuffles it.", "EMOTE")
end

local function drawcard(msg)
	local num = tonumber(msg)
	drawncards = ""
	drawn = {}
	plu = ""
	if not num then
		num = 1
	elseif num > CurrentCard then
		num = CurrentCard
	end
	for i=1,num do
		drawn[i] = deck[CurrentCard]
		CurrentCard = CurrentCard - 1
	end
	drawncards = table.concat(drawn, ", ")
	if num == 1 then plu = "one card" elseif num > #numbers then plu = "a lot of cards" else plu = numbers[num].."cards" end
	SendChatMessage("draws "..plu.." from "..pronouns[gender][2].." deck: "..drawncards..".","EMOTE")
end

local function blackjackDeal()
	drawn = {}
	local output = ""
	local target = UnitName("target")
	for i = 1 , 2 do
		drawn[i] = deck[CurrentCard]
		CurrentCard = CurrentCard - 1
	end
	if target and target ~= user then
		output = string.format("draws two cards and passes them over to %s. The cards being: %s and the %s.",target,drawn[1],drawn[2])
	else
		output = string.format("draws two cards and passes them over. The cards being: %s and the %s.",drawn[1],drawn[2])
	end
	SendChatMessage(output,"EMOTE")
end

local function blackjackHit()
	drawn = {}
	local output = ""
	local target = UnitName("target")
	for i = 1 , 1 do
		drawn[i] = deck[CurrentCard]
		CurrentCard = CurrentCard - 1
	end
	if target and target ~= user then
		output = string.format("draws a single card and passes it over to %s. The card being: %s.",target,drawn[1])
	else
		output = string.format("draws a single card and passes it over. The card being: %s.",drawn[1])
	end
	SendChatMessage(output,"EMOTE")
end

local function tarotshuffle()
	shuffle(tarot)
	CurrentTarot = #tarot
	PlaySound(53186)
	SendChatMessage("picks up "..pronouns[gender][2].." Tarot Deck and shuffles it.", "EMOTE")
end

local function tarotdraw(msg)
	local num = tonumber(msg)
	drawncards = ""
	drawn = {}
	plu = ""
	if not num then
		num = 1
	elseif num > CurrentTarot then
		num = CurrentTarot
	end
	for i=1,num do
		drawn[i] = tarot[CurrentTarot]
		CurrentTarot = CurrentTarot - 1
	end
	if num > 1 then
		for i=1,#drawn do
			if i > 1 then drawncards = drawn[i] .. ", ".. drawncards
			else drawncards = drawn[i] end
		end
	else
		drawncards = drawn[1]
	end
	if num == 1 then plu = "one tarot card" elseif num > #numbers then plu = "a lot of tarot cards" else plu = numbers[num].."tarot cards" end
	SendChatMessage("draws "..plu.." from "..pronouns[gender][2].." deck: "..drawncards..".","EMOTE")
end

local function bottleSpin(msg)
	local Party = {}
	local RandomType = 1
	if #spinList > 0 then
		RandomType = 2
		Party = spinList
	else
		Party = getGroup()
	end
	local Player = getRandomPlayer(RandomType, Party)
	if Player == nil then 
		SELECTED_CHAT_FRAME:AddMessage("No players available to select.")
	else
		if msg == "s" or "S" then
			SELECTED_CHAT_FRAME:AddMessage("|cFFFF7D0ASelected: |r"..Player)
		else
			SendChatMessage("reaches forwards and spins the bottle, after a few moments it stops pointing towards "..Player..".","EMOTE")
		end
	end
end

local function bottleList(msg)
	if msg ~= "" then 
		for name in string.gmatch(msg, "%a+") do
			table.insert(spinList,name)
		end	
	else
		if #spinList > 0 then
			local PlayerOutput = "Players in the List are "
			for i = 1, #spinList do
				PlayerOutput = PlayerOutput..spinList[i]..", "
			end
			SELECTED_CHAT_FRAME:AddMessage(PlayerOutput)
		else
			SELECTED_CHAT_FRAME:AddMessage("No players currently in the list. Please use /spinlist again with the names afterwards.")
		end
	end
end



SLASH_RPEMOTES1 = '/RPE';
SLASH_RPEMOTES2 = '/RPEmotes';
function SlashCmdList.RPEMOTES(msg, editbox)
 for i = 1,#helpTable do
	 SELECTED_CHAT_FRAME:AddMessage("|cFFFF7D0ARP Emotes: |r"..helpTable[i])
 end
end

SLASH_SHUFFLE1 = '/shuffle';
function SlashCmdList.SHUFFLE(msg, editbox)
	shuffledeck()
end

SLASH_DRAW1 = '/draw';
function SlashCmdList.DRAW(msg, editbox)
	if CurrentCard == 0 then shuffledeck() drawcard(msg) else drawcard(msg) end
end

SLASH_DEAL1 = '/deal';
function SlashCmdList.DEAL(msg, editbox)
	if CurrentCard == 0 then shuffledeck() blackjackDeal() else blackjackDeal() end
end

SLASH_HIT1 = '/hit';
function SlashCmdList.HIT(msg, editbox)
	blackjackHit()
end

SLASH_CHECK1 = '/check';
function SlashCmdList.CHECK(msg, editbox)
	SendChatMessage("checks "..pronouns[gender][2].." deck. There are "..CurrentCard.." Cards remaining.","EMOTE")
end

SLASH_BALL1 = '/8ball';
function SlashCmdList.BALL(msg, editbox)
	eightball(msg)
end

SLASH_TSHUFFLE1 = '/tarotshuffle';
SLASH_TSHUFFLE2 = '/tshuffle';
function SlashCmdList.TSHUFFLE(msg, editbox)
	tarotshuffle()
end

SLASH_TDRAW1 = '/tarotdraw';
SLASH_TDRAW2 = '/tdraw';
function SlashCmdList.TDRAW(msg, editbox)
	if CurrentTarot == 0 then tarotshuffle() tarotdraw(msg) else tarotdraw(msg) end
end

SLASH_TCHECK1 = '/tcheck';
SLASH_TCHECK2 = '/tarotcheck';
function SlashCmdList.TCHECK(msg, editbox)
	SendChatMessage("checks "..pronouns[gender][2].." deck. There are "..CurrentTarot.." Cards remaining.","EMOTE")
end

SLASH_FLIP1 = '/flip';
function SlashCmdList.FLIP(msg, editbox)
	local num = math.random(2)
	if num == 1 then Side = "Heads" else Side = "Tails" end
	local output = string.format("flips a coin up into the air. %s catches it in %s palm, the coin showing %s.",pronouns[gender][3],pronouns[gender][2],Side)
	SendChatMessage(output, "EMOTE")
end

SLASH_SPIN1 = '/spin';
function SlashCmdList.SPIN(msg, editbox)
	bottleSpin(msg)
end

SLASH_SPINLIST1 = '/spinlist';
function SlashCmdList.SPINLIST(msg, editbox)
	bottleList(msg)
end

SLASH_SMILENOD1 = '/snod';
SLASH_SMILENOD2 = '/smilenod';
function SlashCmdList.SMILENOD(msg, editbox)
	local emote = "smiles and nods %s head."
	local targetEmote = "smiles at %s and then gives a nod of %s head."
	local target = UnitName("target")
	local output = ""
	if target and target ~= user then
		output = emoteFormat(targetEmote,target,pronouns[gender][2])
	else
		output = emoteFormat(emote,pronouns[gender][2])
	end
	SendChatMessage(output,"EMOTE")
end 

SLASH_WAG1 = '/wag';
function SlashCmdList.WAG(msg, editbox)
	local emote = "wags %s eyebrows suggestively."
	local targetEmote = "wags %s eyebrows suggestively at %s."
	local target = UnitName("target")
	local output = ""
	if target and target ~= user then
		output = emoteFormat(targetEmote,pronouns[gender][2],target)
	else
		output = emoteFormat(emote,pronouns[gender][2])
	end
	SendChatMessage(output,"EMOTE")
end 

SLASH_SMUG1 = '/smug';
SLASH_SMUG2 = '/smuggrin';
function SlashCmdList.SMUG(msg, editbox)
	local emote = "flashes a smug grin."
	local targetEmote = "flashes a smug grin at %s."
	local target = UnitName("target")
	local output = ""
	if target and target ~= user then
		output = emoteFormat(targetEmote,target)
	else
		output = emoteFormat(emote)
	end
	SendChatMessage(output,"EMOTE")
end 

SLASH_SQUINT1 = '/squint';
function SlashCmdList.SQUINT(msg, editbox)
	local emote = "squints and purses %s lips together suspiciously."
	local targetEmote = "squints and purses %s lips together suspiciously at %s."
	local target = UnitName("target")
	local output = ""
	if target and target ~= user then
		output = emoteFormat(targetEmote,pronouns[gender][2],target)
	else
		output = emoteFormat(emote,pronouns[gender][2])
	end
	SendChatMessage(output,"EMOTE")
end 

SLASH_SIP1 = '/sip';
function SlashCmdList.SIP(msg, editbox)
	local drink = "drink"
	local emote = sipEmotes[math.random(#sipEmotes)]
	local output = ""
	if msg ~= "" then
		drink = msg
	end
	output = emoteFormat(emote,pronouns[gender][2],drink,pronouns[gender][2])
	SendChatMessage(output,"EMOTE")
end 

SLASH_SHAKEHEAD1 = '/shakehead';
SLASH_SHAKEHEAD2 = '/shakeh';
function SlashCmdList.SHAKEHEAD(msg, editbox)
	local emote = "shakes %s head."
	local targetEmote = "shakes %s head at %s."
	local target = UnitName("target")
	local output = ""
	if target and target ~= user then
		output = emoteFormat(targetEmote,pronouns[gender][2],target)
	else
		output = emoteFormat(emote,pronouns[gender][2])
	end
	SendChatMessage(output,"EMOTE")
end 
